<h3><?php echo __('Filled forms', 'form-to-pdf');?></h3>
<?php 
    global $wpdb;
    $table_name = $wpdb->prefix . 'form_to_pdf';

    $result = $wpdb->get_results('SELECT alias, MAX(time) as last, COUNT(id) AS count FROM ' . $table_name . ' GROUP BY alias ORDER BY last DESC'); 
?>
<table class="wp-list-table widefat fixed striped posts">
    <thead>
        <tr>
            <th><?php echo __('Form file name', 'form-to-pdf');?></th>
            <th><?php echo __('Filled count', 'form-to-pdf');?></th>
            <th><?php echo __('Last filled', 'form-to-pdf');?></th>
            <th><?php echo __('Download in Excel format', 'form-to-pdf');?></th>
        </tr>
    </thead>
    <tbody>
<?php

    $date_format = get_option( 'date_format' );
    $time_format = get_option( 'time_format' );

    foreach ($result as $item) {
        
        $date_text = date_i18n( $date_format, strtotime($item->last));
        $time_text = date_i18n( $time_format, strtotime($item->last));

        $old = get_option('form_to_pdf_form_'.$item->alias);      
        if ((!$old) or ($old < $item->count)) {
            if (!$old) { $old = 0; }
            $new = '&nbsp;<small>(+'.($item->count - $old).')</small>'; 
            update_option('form_to_pdf_form_'.$item->alias, $item->count, true);
        } else {
            $new = '';
        }

        echo '<tr>'.
             '  <td align="left">'.$item->alias.'</td>'.
             '  <td align="right">'.number_format($item->count, 0, '.', ' ').$new.'</td>'.
             '  <td align="left">'.$date_text.'&nbsp;'.$time_text.'</td>'.
             '  <td align="center">';
        if ($item->count > 0) {
            echo '  <img onclick="form_to_pdf_891_download_excel(\''.$item->alias.'\');" src="'.plugins_url('form-to-pdf/assets/images/').'xls.png" alt="'.__('Download in Excel format', 'form-to-pdf').'" width="24" style="cursor:pointer;" />';
        }
        echo '  </td>'.
             '</tr>';
    }
?>    
    </tbody>
</table>    
