var error_message = [];
var robot_error = false;

jQuery( document ).ready(function() {
    
    jQuery('.form-to-pdf').each(function(){
       var token = jQuery(this).attr('data-token');
       add_robot_filter_block(token); 
    });
    
    jQuery('.from_to_pdf').focusout(function () {
        if(jQuery(this).prop('required')){
            if (jQuery(this).attr('type') != 'checkbox') {
                val = jQuery(this).val();
                if (val == '' || jQuery(this).attr('data-valid') == '0') {
                    jQuery(this).addClass('is-invalid');
                    jQuery(this).closest('.input-group').find('.invalid-feedback').show();
                } else {
                    jQuery(this).removeClass('is-invalid');
                    jQuery(this).closest('.input-group').find('.invalid-feedback').hide();
                }
            } else {
                if (jQuery(this).prop('checked')) {
                    jQuery(this).removeClass('is-invalid');
                    jQuery(this).closest('.input-group').find('.invalid-feedback').hide();
                } else {
                    jQuery(this).addClass('is-invalid');
                    jQuery(this).closest('.input-group').find('.invalid-feedback').show();
                }
            }
        }
    });
});


Number.prototype.formatMoney = function(c, d, t){
var n = this, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? "." : d, 
    t = t == undefined ? "," : t, 
    s = n < 0 ? "-" : "", 
    i = String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))), 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
 };



String.prototype.replaceAll = function(search, replacement) {
    var target = this;
    return target.split(search).join(replacement);
}; 

function strpos (haystack, needle, offset) {
  var i = (haystack + '')
    .indexOf(needle, (offset || 0));
  return i === -1 ? false : i
}
 
function form_to_pdf_891_checkNumberFormat(id) {
    var value = jQuery('#'+id).val();

    var dec = jQuery('#'+id).attr('dec');
    if (typeof dec == 'undefined' || dec == null) {
        dec = '';
    }    
    var sep = jQuery('#'+id).attr('sep');
    if (typeof sep == 'undefined' || sep == null) {
        sep = '';
    }
    var rep = '[^0-9]';
    if (dec != '') {
        rep = '[^0-9'+dec+']';    
    }
    
    var regex = new RegExp(rep, "g");
    value = value.replace(regex, '');

    if (dec != '') {
        var tmp = value.split(dec);
    } else {
        var tmp = [value, ''];
    }
    tmp[0] = (Number(tmp[0])).formatMoney(0, '.', sep);
    if (tmp[0] == '0'  ) { tmp[0] = ''; }

    if (strpos(value, dec)) {
        value = tmp[0] + dec + tmp[1];
    } else {
        value = tmp[0];
    }
    jQuery('#'+id).val(value);
};

function form_to_pdf_891_checkPhoneFormat(id) {
    var value = jQuery('#'+id).val();
    value = value.replace(/[^0-9+-/()\s]/g, '');
    jQuery('#'+id).val(value);
};

function form_to_pdf_891_getData(token) {
    var data = {};
    jQuery('#form-to-pdf-'+token+' :input').each(function(){
        if ((jQuery(this).attr('type') != 'submit') && (jQuery(this).attr('type') != 'button')) {
            if ( jQuery(this).attr('type') == 'checkbox') {
                if (jQuery(this).is(":checked")) {
                    var value = jQuery(this).val();
                    if (value == '') {
                        value = 1;
                    } 
                    data[jQuery(this).attr('id')] = value;
                } else {
                    data[jQuery(this).attr('id')] = 0;
                }                                    
            } else {
                if ( jQuery(this).attr('type') == 'radio') {
                    var name = jQuery(this).attr('name');
                    data[name] = jQuery("input[name='"+name+"']:checked").val();    
                } else {
                    var v = jQuery(this).val();
                    v = v.replace( /<.*?>/g, '' );
                    v = v.replace( /\"/g, '&quot;');
                    v = v.replace( /\'/g, '&rsquo;');
                    data[jQuery(this).attr('id')] = v;
                }
            }
        } 
    });
    
    data.init = eval('form_to_pdf_variables_'+token);
    return data;
}


function form_to_pdf_891_action(token) {
    // Scroll to form top
    var divPosition = jQuery('#form-to-pdf-'+token).offset();
    divPosition.top = divPosition.top - 40;
    jQuery('html, body').animate({scrollTop: divPosition.top}, 'slow');

    jQuery('#form-to-pdf-'+token+'-form').slideUp(500);
    
    setTimeout(function(){
        jQuery('#form-to-pdf-'+token+'-working').slideDown(500);
        error_message = [];
        form_to_pdf_891_checkFormRobots(token);
    }, 500);
}

function form_to_pdf_891_complete(token) {
    jQuery('#form-to-pdf-'+token+'-working').find('.progress-bar').css('width', '100%').attr('aria-value', '100');
    jQuery('#form-to-pdf-'+token+'-working').find('.progress-info').hide();
    jQuery('#form-to-pdf-'+token+'-working').find('.progress').hide();
    if (error_message.length > 0) {
        var html = '<br />' + error_message.join('<br />');
        jQuery('#form-to-pdf-'+token+'-working').find('.progress-info-error').append(html).show();
    } else {
        jQuery('#form-to-pdf-'+token+'-working').find('.progress-info-ok').show();  
    }
}

function form_to_pdf_891_checkFormRobots(token) {
    var variables = eval('form_to_pdf_variables_'+token);
    var data_tmp = {action:     'form_to_pdf_891_check_robots',
                    locale:     variables.locale,
                    token:      token};
    
    data_tmp = robot_filter_get_values(data_tmp);
    
    jQuery.ajax({
        url      : form_to_pdf_891_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(res, result){
            if (res.status != 1) {
                error_message.push(res.message);
                robot_error = true;
                setTimeout(function(){
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '100%').attr('aria-value', '100');
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info').hide();
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress').hide();
                    var html = '<br />' + res.message;
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info-error').append(html).show();
                   
                    
                }, 1000);
            } else {
                jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '25%').attr('aria-value', '25');
                // saveFormData(data, id);

                var data = form_to_pdf_891_getData(res.token); 
                
                if (data.init.save_data == '1') {
                    form_to_pdf_891_save_data(res.token, data);
                } else {
                    if (data.init.send_admin == '1') {
                        form_to_pdf_891_send_admin(res.token, data);
                    } else {
                        jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '50%').attr('aria-value', '50');
                        if (data.init.show_pdf == '1') {
                            form_to_pdf_891_generatePDF(res.token, data);
                        } else {
                            form_to_pdf_891_complete(res.token)
                        }
                    }
                }
                
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function form_to_pdf_891_save_data(token, data) {
    var data_tmp = {action:     'form_to_pdf_891_save_data',
                    data  : data,
                    token : token};
    jQuery.ajax({
        url      : form_to_pdf_891_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(res, result){

            if (res.status != 1) {

                error_message.push(res.message);
                setTimeout(function(){
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '100%').attr('aria-value', '100');
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info').hide();
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress').hide();
                    var html = '<br />' + res.message;
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info-error').append(html).show();
                }, 1000);

            } else {
                
                var data = form_to_pdf_891_getData(res.token); 

                if (data.init.send_admin == '1') {
                    form_to_pdf_891_send_admin(res.token, data);
                } else {
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '50%').attr('aria-value', '50');
                    if (data.init.show_pdf == '1') {
                        form_to_pdf_891_generatePDF(res.token, data);
                    } else {
                        form_to_pdf_891_complete(res.token)
                    }
                }
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}


function form_to_pdf_891_send_admin(token, data) {
    var data_tmp = {action:     'form_to_pdf_891_send_admin',
                    data  : data,
                    token : token};
    jQuery.ajax({
        url      : form_to_pdf_891_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(res, result){

            if (res.status != 1) {

                error_message.push(res.message);
                robot_error = true;
                setTimeout(function(){
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '100%').attr('aria-value', '100');
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info').hide();
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress').hide();
                    var html = '<br />' + res.message;
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info-error').append(html).show();
                }, 1000);

            } else {

                jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '50%').attr('aria-value', '50');
                var data = form_to_pdf_891_getData(res.token);
                if (data.init.show_pdf == '1' || data.init.save_pdf == '1') {
                    form_to_pdf_891_generatePDF(res.token, data)
                } else {
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '75%').attr('aria-value', '75');
                    form_to_pdf_891_complete(res.token)
                }
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function form_to_pdf_891_generatePDF(token, data) {
    
    var set = form_to_pdf_891_getData(token);
    
    var data_tmp = {action:     'form_to_pdf_891_generatePDF',
                    data  : data,
                    save  : set.init.save_pdf,
                    show  : set.init.show_pdf,
                    token : token};
    jQuery.ajax({
        url      : form_to_pdf_891_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(res, result){

            if (res.status != 1) {

                error_message.push(res.message);
                robot_error = true;
                setTimeout(function(){
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '100%').attr('aria-value', '100');
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info').hide();
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress').hide();
                    var html = '<br />' + res.message;
                    jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-info-error').append(html).show();
                }, 1000);

            } else {

                var set = form_to_pdf_891_getData(res.token);

                jQuery('#form-to-pdf-'+res.token+'-working').find('.progress-bar').css('width', '100%').attr('aria-value', '100');
                form_to_pdf_891_complete(res.token);
                
                if (set.init.show_pdf == '1') {
                    var winparams = 'toolbar=1,dependent=1,locationbar=0,scrollbars=1,menubar=1,'+
                                    'resizable,screenX=50,screenY=50,width=850,height=1050';
            
                    var htmlPop = '<embed width=100% height=100%'
                                     + ' type="application/pdf"'
                                     + ' src="data:application/pdf;base64,'
                                     + escape(res.data)
                                     + '"></embed>'; 
            
                    var printWindow = window.open ("", res.token, winparams);
                    printWindow.document.write (htmlPop);
                    // printWindow.print();
                }

                form_to_pdf_891_complete(res.token)
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}
