<?php
/*
Plugin Name: Form to PDF
Plugin URI:  http://dovi42.hu/form-to-pdf
Description: HTML űrlap generálása, majd abból PDF készítése adatbázisba mentés mellett.
Version:     2.47
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: form-to-pdf
Generator:   WP Creator - http://wpcreator.hu - 2020-01-29 12:02:04
*/

if ( !defined( 'ABSPATH' ) ) exit;

if ( is_admin() ) : 
    require dirname(__FILE__) . '/assets/libs/phpspreadsheet/vendor/autoload.php';
endif;
use PhpOffice\PhpSpreadsheet\Cell\Coordinate;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

define('FORM_TO_PDF_961_ROOT', dirname(__FILE__));
define('FORM_TO_PDF_961_VERSION', '2.47');

function form_to_pdf_891_update() {
    require_once ( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'autoupdate.php' ); 
	
	$plugin_current_version = FORM_TO_PDF_961_VERSION; // Current version
	$plugin_remote_path     = 'http://update.dovi42.hu/form-to-pdf/update.php';  
	$plugin_slug            = plugin_basename(__file__);
	$license_user           = get_site_url();
	$license_key            = '<optional license key>';

	if ( $license_user && $license_key && $plugin_remote_path )
	{
		new form_to_pdf_891_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'form_to_pdf_891_update');

$form_to_pdf_891_saved_data = false;

function form_to_pdf_891_get_options() { 

    if (!class_exists('form_to_pdf_891_JFiles')) {
        include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'files.php');
    }
    $files = new form_to_pdf_891_JFiles(dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'templates'); 
    $template = $files->getFolders();
    if (isset($template[0])) {
        $template = $template[0]['filename'];
    } else {
        $template = '';
    }

	$defaults = array(
			'sources'      => 'form',
            'template'     => $template,
			'save_data'    => '1',
            'save_pdf'     => '1',
            'show_pdf'     => '1',
			'send_admin'   => '0',
            'load_awesome' => '0',
            'form'         => '',
            'access'       => 'everyone',
            'google_site_key' => '',
            'google_secret_key' => '',
            'filter_type'  => 'fruits'
		);
	$options = get_option('form_to_pdf_options');

	foreach ($defaults as $key => $value) {
		if (!isset($options[$key])) {
			$options[$key] = $defaults[$key];
		}
	}
	return $options;
}

function form_to_pdf_891_load_textdomain() {
    load_plugin_textdomain( 'form-to-pdf', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'plugins_loaded', 'form_to_pdf_891_load_textdomain' );

function form_to_pdf_891_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=form-to-pdf-setting-admin">' . __( 'Form to PDF settings', 'form-to-pdf' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}

function form_to_pdf_891_notices() {
    if( get_transient( 'form_to_pdf_891_activation_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . __('Required databases created', 'form-to-pdf') . '</p></div>';
        delete_transient( 'form_to_pdf_891_activation_notice' );
    }
    if( get_transient( 'form_to_pdf_891_upgrade_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . get_transient( 'form_to_pdf_891_upgrade_notice' ) . '</p></div>';
        delete_transient( 'form_to_pdf_891_upgrade_notice' );
    }
}

function form_to_pdf_891_activation() {

	$options = form_to_pdf_891_get_options();
	update_option('form_to_pdf_options', $options, true);

    add_action( 'admin_notices', 'form_to_pdf_891_activation_notice' );
    set_transient( 'form_to_pdf_891_activation_notice', 1 );
    
    form_to_pdf_891_create_db();
}

function form_to_pdf_891_deactivation() {
	delete_option('form_to_pdf_options');
}

function form_to_pdf_891_uninstall() {
    global $wpdb;
    $wpdb->query('DROP TABLE IF EXISTS ' . $wpdb->prefix . 'form_to_pdf');

}

function form_to_pdf_891_create_db() {

	global $wpdb;
	$charset_collate = $wpdb->get_charset_collate();
	$table_name = $wpdb->prefix . 'form_to_pdf';

	$sql = "CREATE TABLE IF NOT EXISTS ".$table_name." (
		`id` int(11) NOT NULL AUTO_INCREMENT,
        `alias` varchar(255), 
		`time` datetime DEFAULT CURRENT_TIMESTAMP,
		`data` text NOT NULL,
		UNIQUE KEY id (id)
	) $charset_collate;";

	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );
}


function form_to_pdf_891_upgrade_completed( $upgrader_object, $options ) {
    $our_plugin = plugin_basename( __FILE__ );
    if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
        foreach( $options['plugins'] as $plugin ) {
            if( $plugin == $our_plugin ) {

                $error = false;
                if ($error) {
                    $error_info = __('Update error notice', 'form-to-pdf');
                    set_transient( 'form_to_pdf_891_upgrade_notice', $error_info );
                }
                
                form_to_pdf_891_create_db();
            }
        }
    }
}

if ( is_admin() ){ 
    
    $plugin = plugin_basename( __FILE__ );

    add_filter( "plugin_action_links_$plugin", 'form_to_pdf_891_add_settings_link' );
    add_action( 'admin_notices', 'form_to_pdf_891_notices' );
    register_activation_hook( __FILE__, 'form_to_pdf_891_activation' );
    register_deactivation_hook( __FILE__, 'form_to_pdf_891_deactivation' );
    register_uninstall_hook( __FILE__, 'form_to_pdf_891_uninstall' );
    add_action( 'upgrader_process_complete', 'form_to_pdf_891_upgrade_completed', 10, 2 );

    include( dirname(__file__) .DIRECTORY_SEPARATOR. 'admin' .DIRECTORY_SEPARATOR. 'form-to-pdf-setup.php' );
    $my_settings_page = new form_to_pdf_891_settings();
    
    function form_to_pdf_891_get_extra_meta_links($meta, $file, $data, $status) {

        if (plugin_basename(__FILE__) == $file) {
            $lang = get_bloginfo('language');
            if ($lang == 'hu') {
                $url = 'http://wpdemo.dovi42.hu/form-to-pdf';
            } else {
                $url = 'http://wpdemo.dovi42.hu/form-to-pdf-en';
            } 
            $meta[] = "<a href='".$url."' target='_blank' title='" . __('Detailed description and examples', 'form-to-pdf') . "'>".__('Detailed description and examples', 'form-to-pdf')."</a>";

            $meta[]  = '<a href="https://wordpress.org/support/plugin/form-to-pdf/reviews/">'.
                       __('Please rating!', 'form-to-pdf') . '&nbsp;' .
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '</a>';
        }
        return $meta;
    }
    add_filter("plugin_row_meta", 'form_to_pdf_891_get_extra_meta_links', 10, 4);
    
}

include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'assets/libs/utils.php' );

function form_to_pdf_891_shortcode($args) {

    $shortcode = '';
    if (WP_DEBUG) {
        $shortcode = array();
        foreach ($args as $key => $value) {
            $shortcode[] = $key.'="'.$value.'"';
        }
        $shortcode = '<!-- [form-to-pdf '.implode(' ', $shortcode).'] -->';
    }

    $options = form_to_pdf_891_get_options();
    foreach ($options as $key => $value) {
        if (!isset($args[$key])) {
            $args[$key] = $options[$key];
        }
    }

    $enabled = false;
    switch ($args['access']){ 
    	case 'everyone': 
    	    $enabled = true;
            break;
    
    	case 'registered':
    	    if (is_user_logged_in()) {
    	       $enabled = true;
    	    }
            break;
    
    	case 'administrator':
            if (current_user_can('administrator')) {
     	       $enabled = true;
            } 
            break;

    	case 'guest':
    	    if (!is_user_logged_in()) {
    	       $enabled = true;
    	    }
            break;
    
    	default :
    }        

    if (!$enabled) { return ''; }

    if (!defined('FORM_TO_PDF_891')) {
        // A globális beállítások átadódnak a script-ek meghívásához
        // Global settings are passed to invite scripts
        form_to_pdf_891_styles_and_scripts_to_frontend();
    }

    // Osztály betöltése, ha kell
    // Load class if needed
    if (!class_exists('JFormToPdf891')) {
        include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'class.php');
    }

    // Az alapértelmezett paraméterekkel történik az optiomalizálás
    // Init to default options
    $my_plugin = new JFormToPdf891($args);

    // Prepare options
    // Paraméterek módosítása
    $options = $my_plugin->getSets($args);

    // Prepare content - use $options options
    // Tartalom generálása - a módosított paraméterekkel
    $html = $my_plugin->prepareContent('');
    
    return $shortcode . $html;    
}
add_shortcode('form-to-pdf', 'form_to_pdf_891_shortcode');

function form_to_pdf_891_add_asyncdefer_attribute($tag, $handle) {
    if ($handle == 'google-filter-js') {
        return str_replace( '<script ', '<script async ', $tag );
    } else {
        return $tag;
    }
}
add_filter('script_loader_tag', 'form_to_pdf_891_add_asyncdefer_attribute', 10, 2);

function form_to_pdf_891_add_async_forscript($url)
{
    if (strpos($url, 'recaptcha') === false)
        return $url;
    else if (is_admin())
        return $url;
    else
        return $url . '&render=explicit'; 
}
add_filter('clean_url', 'form_to_pdf_891_add_async_forscript', 11, 1);


function form_to_pdf_891_styles_and_scripts_to_frontend()
{
    global $pagenow;

    define('FORM_TO_PDF_891', 1);

    // Csak a felhasználói oldalon töltődjenek be a szkriptek
    // Only load scripts on the user page
    if (in_array( $pagenow, array( 'post.php', 'page.php', 'index.php' ))) {

        wp_register_style( 'dovi-form', plugins_url( 'form-to-pdf/assets/css/form-to-pdf.css') );
    	wp_enqueue_style( 'dovi-form' );


    	wp_register_script('form-to-pdf-js', plugins_url( 'form-to-pdf/assets/js/form-to-pdf.js' ), array('jquery'), false, true);
		wp_enqueue_script( 'form-to-pdf-js');
		// Ajax hívás engedélyezése
		// Enable call ajax
		wp_localize_script('form-to-pdf-js', 'form_to_pdf_891_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );

        $fruits_data = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'form-to-pdf'));
        // $dovi_form_jsdata = explode('|', __('alma|banán|szeder|cseresznye|narancs|körte|szilva|málna|eper|citrom|őszibarack|szőlő|sárgabarack|görögdinnye|kókusz|sárgadinnye|ananász|kiwi', 'form-to-pdf'));
        wp_localize_script('form-to-pdf-js', 'form_fruits', $fruits_data);
    }
}

function form_to_pdf_891_styles_and_scripts_to_backend()
{
    global $pagenow;
    
    if (isset($_REQUEST['page'])) {
        $page = sanitize_text_field($_REQUEST['page']);
    } else {
        $page = '';
    }
    // Csak akkor töltődik be, amikor ennek a pluginnak a beállításai aktuálisak.
    if (($pagenow == 'options-general.php') and ($page == 'form-to-pdf-setting-admin')) {
    	wp_register_script('form-to-pdf-admin-js', plugins_url( 'form-to-pdf/assets/js/form-to-pdf-admin.js' ), array('jquery'));
		wp_enqueue_script( 'form-to-pdf-admin-js');
        wp_localize_script('form-to-pdf-admin-js', 'form_to_pdf_891_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
        
    }
}
add_action( 'admin_enqueue_scripts', 'form_to_pdf_891_styles_and_scripts_to_backend' );


function form_to_pdf_891_check_robots() {
    $data = $_REQUEST;

    $options = form_to_pdf_891_get_options();
    if ((!empty($options['google_site_key'])) and (!empty($options['google_secret_key']))) {
        $options['filter_type'] == 'fruits';
    }
    
    if ($options['filter_type'] == 'fruits') {

        $fruitName  = sanitize_text_field($_REQUEST['name']);
        $fruitID    = sanitize_text_field($_REQUEST['fruit']);
        if ($fruitID == 0) { $fruitName = null; } else { $fruitID--; }

        $locale = '';
        if (isset($data['locale'])) {
            $locale = $data['locale'];
        }
        if ($locale != '') {
            $locale = apply_filters( 'plugin_locale', $locale, 'form-to-pdf' );
            load_textdomain( 'form-to-pdf-en', WP_PLUGIN_DIR . '/form-to-pdf/languages/form-to-pdf-' . $locale . '.mo' );
            $fruits = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'form-to-pdf-en'));        
        } else {    
            $fruits = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'form-to-pdf'));
            // $fruits = explode('|', __('alma|banán|szeder|cseresznye|narancs|körte|szilva|málna|eper|citrom|őszibarack|szőlő|sárgabarack|görögdinnye|kókusz|sárgadinnye|ananász|kiwi', 'dovi-form'));
        }
    
        if (($fruitName == null) or ($fruitName != $fruits[$fruitID])) {
            $data = array(
                'status'   => 0,
                'message'  => __('Robot controll error', 'form-to-pdf'),
                'token'    => $data['token']
            );
        } else {
            $data = array(
                'status'   => 1,
                'message'  => __('Robot controll ok', 'form-to-pdf'),
                'token'    => $data['token']
            );
        }

    }

    if ($options['filter_type'] == 'google') {

        if (isset($_REQUEST['recaptcha']) && !empty($_REQUEST['recaptcha'])) {
            $response = sanitize_text_field($_REQUEST['recaptcha']);
        }
        $verifyResponse = file_get_contents('https://www.google.com/recaptcha/api/siteverify?secret='.$options['google_secret_key'].'&response='.$response);
        $responseData = json_decode($verifyResponse, true);  
        
        if (!$responseData['success']) {
            
            $errors = implode('<br /', $responseData['error-codes']);
            
            $data = array(
                'status'   => 0,
                'message'  => sprintf(__('Robot controll error', 'form-to-pdf'), $errors),
                'token'    => $data['token']
            );
            
        } else {
            $data = array(
                'status'   => 1,
                'message'  => __('Robot controll ok', 'form-to-pdf'),
                'token'    => $data['token']
            );
        }  
    }

    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_form_to_pdf_891_check_robots', 'form_to_pdf_891_check_robots' );
add_action( 'wp_ajax_form_to_pdf_891_check_robots', 'form_to_pdf_891_check_robots' );


function form_to_pdf_891_get_inputs($options, $token) {

    if (!class_exists('JFormToPdf891')) {
        include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'class.php');
    }
    $class = new JFormToPdf891($options);
    
    $class->template = $options['sources'] .DIRECTORY_SEPARATOR. $options['form'].'.html'; 
    if (!file_exists(ABSPATH . $class->template)) {

        $result = array(
            'status'  => 0,
            'message' => __('Template file not found!', 'form-to-pdf'),
            'token'   => $token
        );
        echo json_encode($result);
        wp_die();
    }
    $html = file_get_contents( ABSPATH . $class->template);
    
    $inputs = array();
    $regex = "/\[INPUT\s*.*?\]/i";
    preg_match_all( $regex, $html, $matches, PREG_SET_ORDER);
    for ($i = 0; $i <= count($matches)-1; $i++) {
    	$tmp = $class->getVariablesItem($matches[$i][0]);
        $inputs[$tmp['id']] = $tmp;
    }
    return $inputs;    
}

function form_to_pdf_891_expand_data($data) {

    global $wp;

    $ip   = form_to_pdf_891_get_IP_address();
    $data['ip'] = $ip;

    $host = form_to_pdf_891_get_Host($ip);
    $data['host'] = $host;
    
    if (is_user_logged_in()) {
        $user = wp_get_current_user();
        $data['wordpress-user'] = $user->display_name;
        $data['wordpress-user-id'] = $user->ID;
    } else {
        $data['wordpress-user'] = '';
        $data['wordpress-user-id'] = '';
    }

    $data['now'] = date_i18n(get_option('date_format')) . ' ' . date(get_option('time_format'));
    $data['date'] = date_i18n(get_option('date_format'));
    $data['time'] = date_i18n(get_option('time_format'));

    $data['url'] = home_url($wp->request);
    $data['blogname'] = get_bloginfo('name');

    return $data;
}

function form_to_pdf_891_modifyHTML($html, $inputs, $data, $options) {
    
    global $wp;

    $data['data-file'] = $options['form'].'.html';
    $data = form_to_pdf_891_expand_data($data);

    $html = str_replace('[IP]', $data['ip'], $html);
    $html = str_replace('[HOST]', $data['host'], $html);

    $html = str_replace('[WORDPRESS-USER]', $data['wordpress-user'], $html);
    $html = str_replace('[WORDPRESS-USER-ID]', $data['wordpress-user-id'], $html);

    $html = str_replace('[NOW]', $data['now'], $html);
    $html = str_replace('[DATE]', $data['date'], $html);
    $html = str_replace('[TIME]', $data['time'], $html);
    
    $html = str_replace('[DATA-FILE]', $data['data-file'], $html);
    $html = str_replace('[URL]', $data['url'], $html);
    $html = str_replace('[BLOGNAME]', $data['blogname'], $html);

    $all = array();

    foreach ($inputs as $key => $input) {
        switch ($input['type']){ 
            case 'date':
                if (isset($input['format'])) {
                    $value = date_i18n( $input['format'], strtotime(sanitize_text_field($data[$key])));
                } else {
                    $value = sanitize_text_field($data[$key]);
                }
                $html = str_replace('['.strtoupper($key).']', $value, $html);
                $all[] = '<tr><td>'.$key.'</td><td>'.$value.'</td></tr>'; 
                break;

            case 'list':
            case 'radio':
                $html = str_replace('['.strtoupper($key).'_VALUE]', sanitize_text_field($data[$key]), $html);
                $all[] = '<tr><td>'.$key.'</td><td>'.sanitize_text_field($data[$key]).'</td></tr>';
                
                $values = array();
                $tmp = explode('|', $input['values']);
                foreach ($tmp as $item) {
                    $i = explode(':', $item);
                    $values[$i[0]] = $i[1];
                }
                $html = str_replace('['.strtoupper($key).'_TEXT]', sanitize_text_field($values[$data[$key]]), $html);
                
                $h = array();
                foreach ($values as $k => $v) {
                    $tmp = '';
                    if ($k == $data[$key]) { 
                        $tmp = '[X]&nbsp;';
                    } else {
                        $tmp = '[&nbsp;&nbsp;]&nbsp;';
                    }
                    $h[] = $tmp . sanitize_text_field($v); 
                }
                $h = implode('<br />', $h);
                $html = str_replace('['.strtoupper($key).']', $h, $html);

                break;
            case 'checkbox':
                if ($data[$key] != 0) {
                    $html = str_replace('['.strtoupper($key).']', sanitize_text_field($data[$key]), $html);
                    $h = '[X]&nbsp;' . sanitize_text_field($input['label']);
                    $html = str_replace('['.strtoupper($key).'_TEXT]', $h, $html);
                } else {
                    $html = str_replace('['.strtoupper($key).']', '', $html);
                    $h = '[&nbsp;&nbsp;]&nbsp;' . sanitize_text_field($input['label']);
                    $html = str_replace('['.strtoupper($key).'_TEXT]', $h, $html);
                }
                $all[] = '<tr><td>'.sanitize_text_field($key).'</td><td>'.sanitize_text_field($data[$key]).'</td></tr>';
                break;

            case 'switch':
                if (isset($input['text'])) {
                    $values = explode('|',$input['text']);
                } else {
                    $values = array('No', 'Yes');
                }
                $ansver = 1 - $data[$key];
                $ansver = $values[$ansver];
                $html = str_replace('['.strtoupper($key).']', sanitize_text_field($ansver), $html);
                $all[] = '<tr><td>'.sanitize_text_field($key).'</td><td>'.sanitize_text_field($data[$key]).'</td></tr>';
                break;
            
            default :
                $html = str_replace('['.strtoupper(sanitize_text_field($key)).']', sanitize_text_field($data[$key]), $html);
                $all[] = '<tr><td>'.sanitize_text_field($key).'</td><td>'.sanitize_text_field($data[$key]).'</td></tr>';
        }

        if (isset($input['value']) and ($input['value'] == 'COOKIE')) {
            setcookie($key, $data[$key], time() + (24 * 365 * 3600), '/');                
        }
    }
    $html = str_replace('[ALL-DATA]', '<table>'.implode('', $all).'</table>', $html);
    
    
    return $html;    
}

function form_to_pdf_891_save_data_action($options, $data) {
    global $wpdb, $form_to_pdf_891_saved_data;

    $table_name = $wpdb->prefix . 'form_to_pdf';
    $wpdb->insert( $table_name, array('alias' => $options['alias'], 'data' => serialize($data)));
    $form_to_pdf_891_saved_data = $wpdb->insert_id;
}
add_action('form_to_pdf_save_data_action', 'form_to_pdf_891_save_data_action', 10, 2);

function form_to_pdf_891_save_data()
{
    global $form_to_pdf_891_saved_data;

    $data = $_REQUEST['data'];
    // Sanitize in form_to_pdf_891_modifyHTML() function
    $token = sanitize_text_field($_REQUEST['token']);
    
    $options = $data['init'];
    unset($data['init']);
    unset($data['fruit']);
    unset($data['fruit_name_'.$token]);
    unset($data['g-recaptcha-response']);

    if ($options['save_data'] == 1) {

        $data = form_to_pdf_891_expand_data($data);
        $data['data-file'] = $options['form'];
        
        if (!isset($data['ip'])) {
            $data['ip']   = form_to_pdf_891_get_IP_address();
        }
        if (!isset($data['host'])) {
            $data['host']   = form_to_pdf_891_get_Host($data['ip']);
        }

        do_action('form_to_pdf_save_data_action', $options, $data);

        if ($form_to_pdf_891_saved_data) {
            $result = array(
                'status'   => 1,
                'token'  => $token,
                'message'  => __('Form data saved', 'form-to-pdf')
            );
        } else {
            $result = array(
                'status'   => 0,
                'token'  => $token,
                'message'  => __('Error saved form data', 'form-to-pdf')
            );
        }

    } else {
        $result = array(
            'status'   => 1,
            'token'  => $token,
            'message'  => __('Settings disabled to save a data', 'form-to-pdf')
        );
    }
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_form_to_pdf_891_save_data', 'form_to_pdf_891_save_data' );
add_action( 'wp_ajax_form_to_pdf_891_save_data', 'form_to_pdf_891_save_data' );



function form_to_pdf_891_send_admin()
{
    $data = $_REQUEST['data'];
    // Sanitize in form_to_pdf_891_modifyHTML() function
    $token = sanitize_text_field($_REQUEST['token']);
    
    $options = $data['init'];
    unset($data['init']);
    unset($data['fruit']);
    unset($data['fruit_name_'.$token]);
    
    $inputs = form_to_pdf_891_get_inputs($options, $token);
    
    $body = $options['sources'] .DIRECTORY_SEPARATOR. $options['form'].'.email.html';
    if (!file_exists(ABSPATH . $body)) {

        $result = array(
            'status'  => 0,
            'message' => __('Email template file not found!', 'form-to-pdf'),
            'token'   => $token
        );
        echo json_encode($result);
        wp_die();
        exit;
    }
    $body = file_get_contents( ABSPATH . $body);
    $body = form_to_pdf_891_modifyHTML($body, $inputs, $data, $options);

    $to = array();

    $admin_email = get_option( 'admin_email' );
    if (is_array($admin_email)) {
        $to = $admin_email;
    } else {
        $to[] = $admin_email;
    }

    if ($options['send_admin'] == 1) {
        $blogusers = get_users('role=Administrator');
        foreach ($blogusers as $user) {
            if (!in_array($user->user_email, $to)) {
                $to[] = $user->user_email;
            }
        }    
    }

    if (has_filter('form_to_pdf_modify_to')) {
        $to = apply_filters('form_to_pdf_modify_to', $to, $data);    
    }

    // META elemek keresése
    $regex = "/\<meta\s*.*?\>/i";
    preg_match_all( $regex, $body, $matches, PREG_SET_ORDER);
    for ($i = 0; $i <= count($matches)-1; $i++) {
        $meta = $matches[$i][0];
        preg_match_all('/(name|content)=("[^"]*")/i',$meta, $t);
        $tags = array();
        for ($j = 0; $j <= count($t[0])-1; $j++) {
        	$tags[$t[1][$j]] = trim($t[2][$j], '"');
        }

        // További címzettek hozzáadása
        if ($tags['name'] == 'sendto') {
            $to_mail = explode(',', $tags['content']);
            foreach ($to_mail as $item) {
                if (!in_array(trim($item), $to)) {
                    $to[] = trim($item);
                }
            }
        }
    }

    
    $headers = array('Content-Type: text/html; charset=UTF-8');    

    if (has_filter('form_to_pdf_modify_bcc')) {
        $bcc = apply_filters('form_to_pdf_modify_bcc', $data);    
        if (!empty($bcc)) {
            foreach ($bcc as $item) {
                $headers[] = 'Bcc: '.$item;
            }
        }
    }

    $regex = "/\<title>(\s*.*?)\<\/title>/i";
    preg_match_all( $regex, $body, $matches, PREG_SET_ORDER);

    if (isset($matches[0][1])) {
        $subject = $matches[0][1];
    } else {
        $subject = __('Filled form', 'form-to-pdf') . ' [' . $options['form'] . ']';
    }

    if ( wp_mail($to, $subject, $body, $headers) ) {
        $result = array(
            'status'   => 1,
            'token'  => $token,
            'message'  => __('Send email', 'form-to-pdf')
        );
    } else {
        $result = array(
            'status'   => 0,
            'token'  => $token,
            'message'  => __('Email sending error', 'form-to-pdf')
        );
        
    }    
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_form_to_pdf_891_send_admin', 'form_to_pdf_891_send_admin' );
add_action( 'wp_ajax_form_to_pdf_891_send_admin', 'form_to_pdf_891_send_admin' );


function form_to_pdf_891_generatePDF()
{
    $data = $_REQUEST['data'];
    // Sanitize in form_to_pdf_891_modifyHTML() function
    $token = sanitize_text_field($_REQUEST['token']);
    
    $options = $data['init'];
    unset($data['init']);
    unset($data['fruit']);
    unset($data['fruit_name_'.$token]);
    
    $inputs = form_to_pdf_891_get_inputs($options, $token);
    
    $html = $options['sources'] .DIRECTORY_SEPARATOR. $options['form'].'.pdf.html';
    if (!file_exists(ABSPATH . $html)) {

        $result = array(
            'status'  => 0,
            'message' => __('PDF template file not found!', 'form-to-pdf'),
            'token'   => $token
        );
        echo json_encode($result);
        wp_die();
        exit;
    }

    $html = file_get_contents( ABSPATH . $html);
    $html = form_to_pdf_891_modifyHTML($html, $inputs, $data, $options);

    // Get the title
    $regex = '/<title>(\s*.*?)<\/title>/s';
    preg_match( $regex, $html, $matches);
    $title = $matches[0][1];
    
    // Get the Header
    $header = '';
    $regex = '/<header>(\s*.*?)<\/header>/s';
    preg_match( $regex, $html, $matches);
    if (count($matches) > 0) {
        $header = $matches[1];
        $html = str_replace($matches[0], '', $html);
    }

    $footer = '';
    // Get the Footer
    $regex = '/<footer>(\s*.*?)<\/footer>/s';
    preg_match( $regex, $html, $matches);
    if (count($matches) > 0) {
        $footer = $matches[1];
        $html = str_replace($matches[0], '', $html);
    }

    // Defaults
    $font = 'opensans';
    $size = '210x297';
    $fontsize = '10';
    $margin = array(10,10,10,10);
    $headerHeight = 0;
    $footerHeight = 0;
    
    // META elemek keresése
    $metas = array();
    $regex = "/\<meta(\s*.*?)\/>/i";
    preg_match_all( $regex, $html, $matches, PREG_SET_ORDER);
    for ($i = 0; $i <= count($matches)-1; $i++) {
        $meta = $matches[$i][1];
        preg_match_all('/(name|content)="([^"]*)"/i',$meta, $tag);
        if (count($tag) > 0) {
            if (isset($tag[2][0])) {
                if (isset($tag[2][1])) {
                    $metas[$tag[2][0]] = $tag[2][1];
                } else {
                    $metas[$tag[2][0]] = '';
                }
                $html = str_replace($matches[$i][0], '', $html);
            }
        }
    }

    // Modify head
    $regex = '/<head>(\s*.*?)<\/head>/s';
    preg_match( $regex, $html, $matches);
    if (count($matches) > 0) {
        $head = $matches[0];
        $head = str_replace("\n", '', $head);
        $html = str_replace($matches[0], $head, $html);
    }

    $filename = date('Y-m-d_H-i-s');

    foreach ($metas as $k => $v) {
        switch ($k){ 
        	case 'size':
            	$size = $v;
                break;
        
        	case 'font':
                $font = $v;
            	break;

        	case 'fontsize':
                $fontsize = $v;
            	break;

        	case 'margin':
                $margin = explode(',', $v);
            	break;

        	case 'header-height':
                $headerHeight = $v;
            	break;

        	case 'footer-height':
                $footerHeight = $v;
            	break;

        	case 'filename':
                $filename = $v;
            	break;
        }
    }

    //require_once( dirname(__file__) . '/assets/libs/mPDF/mpdf.php' );
    require_once( dirname(__file__) . '/assets/libs/vendor/autoload.php' );

	// public function __construct($mode = '', $format = 'A4', $default_font_size = 0, $default_font = '', $mgl = 15, $mgr = 15, $mgt = 16, $mgb = 16, $mgh = 9, $mgf = 9, $orientation = 'P')
    // $mpdf = new \mPDF('utf-8', explode('x', $size), $fontsize, $font, $margin[3], $margin[1], $margin[0], $margin[2]);
    $size = explode('x', $size);
    $mpdf = new \Mpdf\Mpdf([
            'mode'              => 'utf-8',
            'format'            => [$size[0], $size[1]],
            'default_font_size' => $fontsize,
        	'default_font'      => $font,
            'margin_left'       => $margin[3],        
            'margin_right'      => $margin[1],        
            'margin_top'        => $margin[0],        
            'margin_bottom'     => $margin[2]        
        ]);

    if ($header != '') {
        $header = str_replace('[PAGES]', '{nbpg}', $header);
        $header = str_replace('[PAGE]', '{PAGENO}', $header);
        $mpdf->setAutoTopMargin = 'stretch';
        $mpdf->SetHTMLHeader($header);
    }
    if ($footer != '') {
        $footer = str_replace('[PAGES]', '{nbpg}', $footer);
        $footer = str_replace('[PAGE]', '{PAGENO}', $footer);
        $mpdf->setAutoBottomMargin = 'stretch';
        $mpdf->SetHTMLFooter($footer);
    }

    $mpdf->WriteHTML($html);    
    
    $pdf_code = '';
    if ($options['show_pdf'] == 1) {
        $pdf_code = base64_encode( $mpdf->Output(dirname(__file__) .DIRECTORY_SEPARATOR. 'teszt.pdf', 'S') );
    }

    if ($options['save_pdf'] == 1) {
        
        if (!class_exists('form_to_pdf_891_JFiles')) {
            include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'files.php');
        }
        
        $upload_dir = wp_get_upload_dir();
        $upload_dir = $upload_dir['basedir'];
        
        $files = new form_to_pdf_891_JFiles($upload_dir); 
        $files->checkFolder('form-to-pdf');
        
        $filename = $files->getAlias($filename);
        $filename = $files->getEmptyName($filename.'.pdf', 'form-to-pdf');
        
        $mpdf->Output($upload_dir .DIRECTORY_SEPARATOR. 'form-to-pdf' .DIRECTORY_SEPARATOR. $filename, 'F');
        chmod($upload_dir .DIRECTORY_SEPARATOR. 'form-to-pdf' .DIRECTORY_SEPARATOR. $filename, 0664);
        
        //$pdf_code = base64_encode( $mpdf->Output(dirname(__file__) .DIRECTORY_SEPARATOR. 'teszt.pdf', 'S') );
    }


    $result = array(
            'status' => 1,
            'token'  => $token,
            'data'   => $pdf_code
        );
    echo json_encode($result);
    wp_die();
}
add_action( 'wp_ajax_nopriv_form_to_pdf_891_generatePDF', 'form_to_pdf_891_generatePDF' );
add_action( 'wp_ajax_form_to_pdf_891_generatePDF', 'form_to_pdf_891_generatePDF' );

function form_to_pdf_891_set_date_default_timezone_set() {
    $time_zone = get_option('timezone_string');
    ini_set('date.timezone', $time_zone);
}
add_action('init', 'form_to_pdf_891_set_date_default_timezone_set');

function form_to_pdf_891_download_excel()
{
    global $wpdb;

    $alias = sanitize_text_field($_REQUEST['alias']);
    if (empty($alias)) {
        $result = array(
                'status'  => 0,
                'message' => __('From alias is empty!', 'form-to-pdf')
            );
        echo json_encode($result);
        wp_die();
    }

    $options = form_to_pdf_891_get_options();
    $options['form'] = $alias;
    $inputs = form_to_pdf_891_get_inputs($options, null);

    $table_name = $wpdb->prefix . 'form_to_pdf';
    $items = $wpdb->get_results('SELECT * FROM ' . $table_name . 
                                ' WHERE alias = "'.$alias.'"' .
                                ' ORDER BY time DESC'); 

    $index = array();
    foreach ($items as $item) {
        $tmp = unserialize($item->data);
        foreach ($tmp as $key => $value) {
            if (!in_array($key, $index)) {
                if ($key != 'g-recaptcha-response') {
                    $index[] = $key;
                }
            }
        }
    }
    if (!in_array('timestamp', $index)) {
        $index[] = 'timestamp';
    }

    // Válaszokat tartalmazó tömb felépítése
    $xls = array();
    foreach ($items as $item) {
        $tmp = unserialize($item->data);
        $t = array();
        foreach ($index as $key) {
            switch ($key){ 
            	case 'action':
            	case 'fruit':
                case 'generated-pdf':
                	break;
            
            	case 'data-file':
                    $t[$key] = base64_decode($tmp[$key]);
            	    break;
            
            	case 'timestamp':
            	    $t[$key] = $item->time;
                    break;
            
            	default :
                    $t[$key] = $tmp[$key];
            }
        }
        $xls[] = $t;
    }

    if (count($xls) < 1) {
        $data = array(
            'status'   => 0,
            'message'  => __('Nothing filled data.', 'form-to-pdf')
        );
        echo json_encode($data);          
        wp_die();
    } else {
        $filename = $alias . '.xlsx';
        $user = wp_get_current_user(); 

        $spreadsheet = new Spreadsheet();
        $spreadsheet->getProperties()
            ->setCreator(get_bloginfo('name'))
            ->setLastModifiedBy($user->display_name)
            ->setTitle($alias)
            ->setSubject(__('XLS EXPORT DATA', 'form-to-pdf'))
            ->setDescription(get_bloginfo('url'))
            ->setCategory(__('XLS EXPORT DATA', 'form-to-pdf'))
            ->setKeywords('');        

        $css = array(
            'font'  => array(
                'bold'  => false,
                'color' => array('rgb' => '000000'),
                'size'  => 10,
                'name'  => 'Tahoma'
                ),
            'alignment' => array(
                'vertical' => \PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER,
                'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT                    
                )
            );

        $header_css = array(
            'font'  => array(
                'bold'  => true,
                'color' => array('rgb' => '000000'),
                'size'  => 10,
                'name'  => 'Tahoma'
                ),
            'alignment' => array(
                'vertical' => \PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER,
                'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER                    
                ),
            'fill' => array(
                'fillType'  => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                'startColor' => array('rgb' => 'EFEFEF')
                ),
            'borders' => array(
                'left' => array(
                    'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
                    'color' => array('rgb' => '000000')
                    ),
                'right' => array(
                    'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN,
                    'color' => array('rgb' => '000000')
                    ),
                'bottom' => array(
                    'borderStyle' => \PhpOffice\PhpSpreadsheet\Style\Border::BORDER_MEDIUM,
                    'color' => array('rgb' => '000000')
                    )
                )
            );

        $spreadsheet->getDefaultStyle()->applyFromArray($css);

        $sheet = $spreadsheet->getActiveSheet();
        $line = 1;
        $col = 1;
        // Fejléc sor kiírása Excel-be
        foreach ($index as $key) {
            $sheet->setCellValue(Coordinate::stringFromColumnIndex($col).$line, $key);
            $sheet->getStyle(Coordinate::stringFromColumnIndex($col).$line)->applyFromArray($header_css);
            $sheet->getColumnDimension(Coordinate::stringFromColumnIndex($col))->setAutoSize(true);               
            $col++;
        }
        $line++; 

        // Adatok kiírása Excel-be
        foreach ($xls as $row) {
            $col = 1;
            foreach ($index as $key) {
                if (isset($inputs[$key])) {
                    switch ($inputs[$key]['type']){ 
                    	case 'number':
                    	   $row[$key] = str_replace(',', '.', $row[$key]);
                           $row[$key] = preg_replace('/[^.0-9]/', '', $row[$key]);
                           break;
                    
                    	default :
    
                    }
                }
                $sheet->setCellValue(Coordinate::stringFromColumnIndex($col).$line, $row[$key]);
                $col++;
            }
            $line++;
        }
        $title = $alias;
        $sheet->setTitle($title);


        $writer = new Xlsx($spreadsheet);
        $file = dirname(__file__) . '/xls/' . $filename;
        try {
            $writer->save($file);
            $status = 1;
            $message = __('XLS generate ok.', 'form-to-pdf');
        } catch (Exception $e) {
            $status = 0;
            $message = 'ERROR: '. $e->getMessage();
        }
        $data = array(
            'status'   => $status,
            'file' => plugins_url( 'xls/' . $filename, __file__ ),  
            'message'  => $message
        );
        echo json_encode($data);          
        wp_die();

    }
    
}
//add_action( 'wp_ajax_nopriv_form_to_pdf_891_download_excel', 'form_to_pdf_891_download_excel' );
add_action( 'wp_ajax_form_to_pdf_891_download_excel', 'form_to_pdf_891_download_excel' );
