<?php

require_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'input.php');

class JInput_form_to_pdf_891_checkbox extends form_to_pdf_891_JInput
{
    public function __construct($sets, $input, $variables)
    {
        parent::__construct($sets, $input, $variables);
        
        $this->type = 'checkbox';

        if (isset($sets['label'])) {
            $this->sets['label'] = $sets['label']; 
        }
    }

    public function renderHTML()
    {
        $html = parent::renderHTML();
        $html = str_replace('[SIMPLE_ID]', $this->sets['id'], $html);
        $html = str_replace('[LABEL]', $this->sets['label'], $html);
        
        $checked = '';
        if (isset($this->sets['checked'])) {
            $checked = 'CHECKED';
        } 
        $html = str_replace('[CHECKED]', $checked, $html);
        
        return $html;
    }
    
    public function renderHTML_old()
    {
        if (isset($_REQUEST[$this->sets['id']])) {
            $value = sanitize_text_field($_REQUEST[$this->sets['id']]);
        } else {
            if (isset($this->sets['value'])) {
                $value = $this->sets['value'];
            } else {
                $value = '';
            }
        }
        if (isset($this->sets['class'])) { $class = $this->sets['class']; } else { $class = '';}
        if (isset($this->sets['invalid'])) { $invalidText = $this->sets['invalid']; } else { $invalidText = '';}
        if (isset($this->sets['other'])) { $other = $this->sets['other']; } else { $other = '';}

        if (isset($this->sets['required'])) { 
            $required = 'required="required"';
            $check = 'onkeypress="form_item_check(\''.$this->sets['id'].'\');" '; 
        } else { 
            $required = '';
            $check = '';
        }

        if (isset($this->sets['checked'])) {
            $checked = 'CHECKED';
        } else {
            if ($value == 1) {
                $checked = 'CHECKED';
            } else {
                $checked = '';
            }
        }

        
        $html = "\r\n" . 
                '<div class="custom-control custom-checkbox">' . "\r\n" .
                '   <input type="checkbox" class="'.$class.' custom-control-input" id="'.$this->sets['id'].'" name="'.$this->sets['id'].'" value="1" '.$checked.' '.$required.' '.$check.' '.$other.'>' . "\r\n" .
                '   <label class="custom-control-label" for="'.$this->sets['id'].'">'.$this->sets['label'].'</label>' . "\r\n" .
                '</div>' . "\r\n"; 

        if ($invalidText != '') {
            $html .= '   <div class="invalid-feedback">' . "\r\n" .
                     '       ' . $invalidText . "\r\n" .
                     '   </div>' . "\r\n";
        }
        if (isset($this->sets['description'])) {
            $html .= '<small class="form-text text-muted">' .  $this->sets['description'] . '</small>' .  "\r\n";
        }

        return $html;
    }
}

?>