<?php

    if ( !defined( 'ABSPATH' ) ) exit;

    class JFormToPdf891 extends stdClass
    {
        private $options = null;
        public $variables = array();
        private $token = null;
        public $template = null;
        private $inputs = array();
        private $template_folder = '';

        
        public function __construct($options)
        {
            $this->options = $options;
        }

        private function getToken()
        {
            $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
            $token = '';
            for ($i = 1; $i <= 10; $i++) {
            	$token .= substr($chars, rand(0, strlen($chars)-1), 1);
            }                
            return $token;
        }

        function getSets($text) 
        {
/*
            // A TinyMCE egy idióta. Felcseréli az idézőjelt karaktereket.
            // TinyMCE is idiot: replace quot characters...
            $text = preg_replace('/\&\#....\;/','"',$text);
            
            preg_match_all('/(\w+)=[\'"]([^\'"]*)/', $text, $vars);
            $this->variables = $this->options;
            for ($i = 0; $i <= count($vars[0])-1; $i++) {
            	$this->variables[$vars[1][$i]] = $vars[2][$i];
            }
*/          
            $this->variables = $this->options;
  
            $this->token = $this->getToken();

            $user = wp_get_current_user();
            $this->variables['wordpress-user'] = $user->display_name;
            $this->variables['alias'] = form_to_pdf_891_getAlias($this->variables['form']);

            if (isset($this->variables['template'])) {
                if (substr($this->variables['template'], 0, 5) == 'theme') {
                    $path = get_stylesheet_directory() .DIRECTORY_SEPARATOR. 'form-to-pdf' .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. substr($this->variables['template'], 6);
                    $url = get_stylesheet_directory_uri() .DIRECTORY_SEPARATOR. 'form-to-pdf' .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. substr($this->variables['template'], 6);  
                } else {
                    $path = dirname(__file__) .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. $this->variables['template'];
                    $url = plugins_url( 'form-to-pdf/libs/templates');
                }
                if (!class_exists('form_to_pdf_891_JFiles')) {
                    include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'files.php');
                }
                
                $this->template_folder = $path;
                
                $files = new form_to_pdf_891_JFiles($path); 
                $files->allowExt = array('css');
                $css = $files->getFiles();
                
                for ($i = 0; $i <= count($css)-1; $i++) {
                    wp_register_style( 'dovi-form-template-'.$i, $url .DIRECTORY_SEPARATOR. $this->variables['template'] .DIRECTORY_SEPARATOR. $css[$i]['filename'] );
                	wp_enqueue_style( 'dovi-form-template-'.$i );
                }
            }

            // Javascript változók átadása
            // Set the javascript values
            if (count($this->variables) > 0) {
    			wp_register_script('form-to-pdf-'.$this->token.'-variables-js', '', array('jquery'), false, true);
    			wp_localize_script('form-to-pdf-'.$this->token.'-variables-js', 'form_to_pdf_variables_'.$this->token, $this->variables);
    			wp_enqueue_script('form-to-pdf-'.$this->token.'-variables-js');
            }
            if ($this->variables['load_awesome'] == 1) {
                wp_register_style('awesome', 'https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css', false, '4.7.0', null);
                wp_enqueue_style('awesome');
            }

            if (($this->options['filter_type'] != 'fruits') and (!empty($this->options['google_site_key'])) and (!empty($this->options['google_secret_key']))) {
                wp_register_script('robot-filter-js', plugins_url( 'form-to-pdf/assets/js/robot-filter-google.js', FORM_TO_PDF_961_ROOT ), array('form-to-pdf-js'));
                wp_add_inline_script( 'robot-filter-js', 'var google_filter_site_key = "'.$this->options['google_site_key'].'";', 'before' );
                wp_enqueue_script('robot-filter-js' );
                wp_register_script('google-filter-js', 'https://www.google.com/recaptcha/api.js', array('robot-filter-js'));
                wp_enqueue_script('google-filter-js' );
            
            } else {
                $this->options['filter_type'] = 'fruits';                
            }

            
            if ($this->options['filter_type'] == 'fruits') {

                if (isset($this->variables['locale'])) {
                    $locale = apply_filters( 'plugin_locale', $this->variables['locale'], 'form-to-pdf' );
                    load_textdomain( 'form-to-pdf-en', WP_PLUGIN_DIR . '/form-to-pdf/languages/form-to-pdf-' . $locale . '.mo' );
                    $title = __('Filtering Robots', 'form-to-pdf-en');
                    $need  = __('We need to make sure that you are not a robot. Therefore, we ask you to mark the following fruit:', 'form-to-pdf-en');
                    
                } else {
                    $title = __('Filtering Robots', 'form-to-pdf');
                    $need  = __('We need to make sure that you are not a robot. Therefore, we ask you to mark the following fruit:', 'form-to-pdf');
                }

                $fruits_data = explode('|', __('apple|banana|blackberry|cherry|orange|pear|plum|raspberry|strawberry|lemon|peach|grapes|apricot|watermelon|coconut|melon|pineapple|kiwi', 'form-to-pdf'));
                wp_register_style('robot-filter', plugins_url( 'form-to-pdf/assets/css/robot-filter.css', FORM_TO_PDF_961_ROOT ) );
    			wp_enqueue_style( 'robot-filter' );
                
                wp_register_script('robot-filter-js', plugins_url( 'form-to-pdf/assets/js/robot-filter.js', FORM_TO_PDF_961_ROOT ), array('jquery'));
                wp_localize_script('robot-filter-js', 'fruits', $fruits_data);
                

                wp_add_inline_script( 'robot-filter-js', 'var fruits_url = "'.plugins_url( 'form-to-pdf/assets/images/' ).'";', 'before' );
                wp_add_inline_script( 'robot-filter-js', 'var filter_title = "'.$title.'";', 'before' );
                wp_add_inline_script( 'robot-filter-js', 'var filter_text = "'.$need.'";', 'before' );
                wp_add_inline_script( 'robot-filter-js', 'var filter_error = "'. __('<strong>Error checking robot!</strong> The selected fruit is not suitable.', 'form-to-pdf').'";', 'before' );
            	wp_enqueue_script('robot-filter-js' );

            }
                        
            return $this->variables;
        }

        function prepareContent($content)
        {   
            
            if ($this->variables == null) {
                $this->variables = $this->options;
            }

            if (isset($this->variables['locale'])) {
                $sendText = __('Submit form', 'form-to-pdf-en');
                $waitText = __('Data processing is in progress', 'form-to-pdf-en');
            } else {
                $sendText = __('Submit form', 'form-to-pdf');
                $waitText = __('Data processing is in progress', 'form-to-pdf');
            }
            
            $this->template = $this->variables['sources'] .DIRECTORY_SEPARATOR. $this->variables['form'].'.html'; 
            if (!file_exists(ABSPATH . $this->template)) {
                $html = $this->showError(
                        __('Template file not found!', 'form-to-pdf'),
                        $this->template,
                        $this->variables['template']
                    );
                return $html;                
            }
            $html = file_get_contents( ABSPATH . $this->template);
            $html = $this->getVariables($html);

            wp_localize_script('form-to-pdf-'.$this->token.'-variables-js', 'form_to_pdf_inputs_'.$this->token, $this->inputs);
            
            $html = "\r\n" . 
                    '<form id="form-to-pdf-'.$this->token.'" class="form-to-pdf" data-token="'.$this->token.'" onsubmit="form_to_pdf_891_action(\''.$this->token.'\');return false;">' . "\r\n" .
                    '  <div id="form-to-pdf-'.$this->token.'-form" class="data-form">' . "\r\n" .
                    $html . "\r\n" .
                    '   <div style="text-align:center;">' . "\r\n". 
                    '       <button type="submit" class="btn btn-primary" id="form_to_pdf_submit_'.$this->token.'">'.$sendText.'</button>' . "\r\n" .
                    '   </div>' . "\r\n". 
                    '</div>' . "\r\n" .
                    '<div style="clear:both;"></div>' . "\r\n";
                    
            $html .= '  <div id="form-to-pdf-'.$this->token.'-working" class="data-process">' . "\r\n" .   
                     '      <div class="progress">' . "\r\n" .
                     '          <div class="progress-bar progress-bar-striped progress-bar-animated bg-success" role="progressbar" style="width: 0%" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"></div>' . "\r\n" .
                     '      </div>' . "\r\n" .
                     '      <div class="small">' . "\r\n" .
                     '          <span class="progress-info"><img src="'.plugins_url( 'form-to-pdf/assets/images/wait.gif' ).'" style="width:16px;height: 16px;margin-right: 6px;">' . $waitText . '</span>' . "\r\n" . 
                     '          <span class="progress-info-error" style="display:none;">' . __('Error processing: ', 'form-to-pdf') . '</span>' . "\r\n" . 
                     '          <span class="progress-info-ok" style="display:none;">' . __('Data processed. Thanks!', 'form-to-pdf') . '</span>' . "\r\n" . 
                     '      </div>' . "\r\n" .
                     '  </div>' . "\r\n" .         
                     '</form>' . "\r\n";
                
            return $html;
        }

        function getVariables($html)
        {
            $regex = "/\[INPUT\s*.*?\]/i";
            preg_match_all( $regex, $html, $matches, PREG_SET_ORDER);
            
            for ($i = 0; $i <= count($matches)-1; $i++) {
            	$html = $this->renderVariables($html, $matches[$i][0]);
            }
            return $html;
        }

        function getVariablesItem($input) 
        {
            preg_match_all('/(\w+)=[\"]([^\"]*)/', $input, $vars);
            $sets = array();
            for ($i = 0; $i <= count($vars[0])-1; $i++) {
            	$sets[$vars[1][$i]] = $vars[2][$i];
            }

            $pos = strpos(strtolower($input), 'required');
            if ($pos !== false) {
                $sets['required'] = 1;
            }

            $pos = strpos(strtolower($input), 'readonly');
            if ($pos !== false) {
                $sets['readonly'] = 1;
            }
        
            $pos = strpos(strtolower($input), 'checked');
            if ($pos !== false) {
                $sets['checked'] = 1;
            }
            $tmp = $sets;
            unset($tmp['id']);
            $this->inputs[$sets['id']] = $tmp;
            
            $sets['template'] = $this->template_folder;
            
            return $sets;
        }

        function renderVariables($html, $input)
        {

            $sets = $this->getVariablesItem($input);

            $sets['template'] = $this->template_folder;

            switch ($sets['type']){
                
                case 'hidden':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_hidden($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'text':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_text($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;
            
                case 'password':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_password($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'number':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_number($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'date':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_date($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'time':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_time($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'email':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_email($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'phone':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_phone($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'url':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_url($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'mask':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_mask($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'textarea':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_textarea($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'list':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_list($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'radio':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_radio($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'checkbox':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_checkbox($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;

                case 'switch':
                    include_once(dirname(__file__) .DIRECTORY_SEPARATOR. $sets['type'].'.php');
                    $tmpl = new JInput_form_to_pdf_891_switch($sets, $input, $this->variables);
                    $html = str_replace($input, $tmpl->renderHTML(), $html);
                    break;


                default:
                    $message = $this->showError(
                            __('Input type not supported:', 'form-to-pdf') . ' <strong>' . $sets['type'] . '</strong>',
                            $input,
                            $sets['template']
                        );
                    $html = str_replace($input, $message, $html);
            }
            return $html;

        }
        
        function showError($text = '', $info = '', $template = '')
        {
            if (file_exists($template .DIRECTORY_SEPARATOR. 'error.html')) {
                $html = file_get_contents($template .DIRECTORY_SEPARATOR. 'error.html');
            } else {
                $html = file_get_contents(dirname(__file__) .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. 'error.html');
            }
            if ($template != '') {
                $file = dirname(__file__) .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. $template .DIRECTORY_SEPARATOR. 'error.html';
                if (file_exists($file)) {
                    $html = file_get_contents($file);    
                }   
            }   
            $html = str_replace('[TEXT]', $text, $html);
            $html = str_replace('[INFO]', $info, $html);
            
            return $html; 
        }
        
}        
