<?php

class form_to_pdf_891_JInput extends stdClass
{
    public $sets = array();
    public $require_styles  = null;
    public $require_scripts = null;
    public $type = '';
    private $save_sets = array();
    private $template_folder = '';

    public function __construct($sets, $input, $variables)
    {
        $this->template_folder = $sets['template'];
        unset($sets['template']);
        
        unset($sets['type']);
        
        $this->save_sets = $sets;
        
        if (isset($sets['id'])) {
            $this->sets['id'] = $sets['id']; 
            if (!$this->checkID()) {
                $html = $this->getTemplate('error');
                $html = str_replace('[TEXT]', __('ID only english characters or numbers!', 'form-to-pdf') . ' <strong>"'.$this->sets['id'].'"</strong>', $html);
                $html = str_replace('[INFO]', $input, $html);
                echo $html;
            }
        } else {
                $html = $this->getTemplate('error');
                $html = str_replace('[TEXT]', __('Input ID not declarated!', 'form-to-pdf'), $html);
                $html = str_replace('[INFO]', $input, $html);
                echo $html;
        }
        if (isset($sets['icon'])) {
            $this->sets['icon'] = $sets['icon']; 
        }

        if (isset($sets['value'])) {
            $check = strtoupper($sets['value']);
            if (empty($check)) {
                $check = '-1';
            }
            switch ($check){ 
            	case 'COOKIE':
                    if (isset($_REQUEST[$this->sets['id']])) {
                        $this->sets['value'] = sanitize_text_field($_REQUEST[$sets['value']]);
                    } else {
                        $this->sets['value'] = '';
                    }
                    break;
            
            	case '-1':
            	    $this->sets['value'] = '';
                    break;
            
            	case 'SHORTCODE':
            	    if (isset($variables[$sets['id']])) {
            	       $this->sets['value'] = $variables[$sets['id']];    
            	    } else {
            	       $this->sets['value'] = '';
            	    }    
                    break;
            
            	default :
                    if (isset($sets['value'])) {
                        $this->sets['value'] = $sets['value'];
                    } else {
                        $this->sets['value'] = '';
                    }
            }
        } else {
            $this->sets['value'] = '';
        }
        if (isset($sets['required'])) {
            $this->sets['required'] = true; 
        }
        if (isset($sets['readonly'])) {
            $this->sets['readonly'] = true; 
        }
        if (isset($sets['invalid'])) {
            $this->sets['invalid'] = $sets['invalid']; 
        }
        if (isset($sets['description'])) {
            $this->sets['description'] = $sets['description']; 
        }
        if (isset($sets['placeholder'])) {
            $this->sets['placeholder'] = $sets['placeholder']; 
        }
        if (isset($sets['class'])) {
            $this->sets['class'] = $sets['class'] . ' from_to_pdf'; 
        } else {
            $this->sets['class'] = 'from_to_pdf';
        }
        
        $this->getStyles();
        $this->getscripts();
    }

    function getID()
    {
        if (isset($this->sets['id'])) {
            return 'id="'.$this->sets['id'].'" name="'.$this->sets['id'].'"';
        }
        return '';
    }

    function getIcon()
    {
        if ($this->sets['icon'] != '') {
            return '<i class="' . $this->sets['icon'] . '"></i>';  
        } 
        return '';
    }

    function getRequired()
    {
        if (isset($this->sets['required'])) {
            return 'required="required"';
        }
        return '';
    }

    function getReadonly()
    {
        if (isset($this->sets['readonly'])) {
            return 'readonly';
        }
        return '';
    }


    function getRequiredHTML()
    {
        if (isset($this->sets['required'])) {
            $invalidText = '';
            if (isset($this->sets['invalid'])) {
                $invalidText = $this->sets['invalid'];
            }
            $html = '   <div class="input-group-append require-flag" data-toggle="tooltip" title="'.$invalidText.'">' . "\r\n" .
                    '       <span class="input-group-text" id="basic-addon1">*</span>' . "\r\n" . 
                    '   </div>' . "\r\n";
            return $html;
        }
        return '';
    }


    function getInvalid()
    {
        if (isset($this->sets['invalid'])) {
            return '<div class="invalid-feedback">' . $this->sets['invalid'] . '</div>' . "\r\n";
        }
        return '';
    }

    function getDescription()
    {
        if (isset($this->sets['description'])) {
            return '<small class="form-text text-muted">' .  $this->sets['description'] . '</small>' .  "\r\n";
        }
        return '';
    }

    function getPlaceholder()
    {
        if (isset($this->sets['placeholder'])) {
            return 'placeholder="'.$this->sets['placeholder'].'"' .  "\r\n";
        }
        return '';
    }

    function getClass()
    {
        if (isset($this->sets['class'])) {
            return $this->sets['class'];
        }
        return '';
    }

    function getStyles()
    {
        return true;
    }
    
    function getScripts()
    {
        return true;
    }

    function getOther()
    {
        $other = array();
        foreach ($this->save_sets as $key => $value) {
            if (!isset($this->sets[$key])) {
                $other[] = $key . '="'.$value.'"';
            }
        }
        $other = implode(' ', $other);
        return $other;
    }

    function getValue()
    {
        return $this->sets['value'];
    }

    private function checkID()
    {
        $str = $this->sets['id'];
        $str = str_replace('-', ' ', $str);
        $str = preg_replace(array('/\s+/','/[^A-Za-z0-9\_]/'), array('_',''), $str);
        if ($str != $this->sets['id']) {
            return false;
        }
        return true;
    }

    function getTemplate($type)
    {
        if (file_exists($this->template_folder .DIRECTORY_SEPARATOR. $type.'.html')) {
            $html = file_get_contents($this->template_folder .DIRECTORY_SEPARATOR. $type.'.html');
            return $html;    
        }
        if ($type != 'error') {
            $html = $this->getTemplate('error');
            $html = str_replace('[TEXT]', __('Template file not found!', 'form-to-pdf') . ' <strong>"'.$type.'.html"</strong>', $html);
            $html = str_replace('[INFO]', $this->template_folder .DIRECTORY_SEPARATOR. $type.'.html', $html);
        } else {
            $html = file_get_contents(dirname(__file__) .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. 'error.html');
            $html = str_replace('[TEXT]', __('Template file not found!', 'form-to-pdf') . ' <strong>"'.$type.'.html"</strong>', $html);
            $html = str_replace('[INFO]', $this->template_folder .DIRECTORY_SEPARATOR. $type.'.html', $html);
        }
        return $html;
    }
    
    function renderHTML()
    {

        $html = $this->getTemplate($this->type);

        $icon = '';
        if ((isset($this->sets['icon'])) and ($this->sets['icon'] != '')) {
            $icon = $this->getTemplate('icon');
            $icon = str_replace('[ICON]', $this->getIcon(), $icon);
        }
        $html = str_replace('[ICON]', $icon, $html);
        $html = str_replace('[VALUE]', $this->getValue(), $html);
        $html = str_replace('[CLASS]', $this->getClass(), $html);
        $html = str_replace('[ID]', $this->getID(), $html);
        $html = str_replace('[PLACEHOLDER]', $this->getPlaceholder(), $html);
        $html = str_replace('[REQUIRED]', $this->getRequired(), $html);
        $html = str_replace('[READONLY]', $this->getReadonly(), $html);
        $html = str_replace('[OTHER]', $this->getOther(), $html);

        $html = str_replace('[REQUIRED_HTML]', $this->getRequiredHTML(), $html);
        $html = str_replace('[INVALID]', $this->getInvalid(), $html);
        $html = str_replace('[DESCRIPTION]', $this->getDescription(), $html);
        
        return $html;
    }
    

}
