<?php

require_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'input.php');

class JInput_form_to_pdf_891_radio extends form_to_pdf_891_JInput
{
    public function __construct($sets, $input, $variables)
    {
        parent::__construct($sets, $input, $variables);
        
        $this->type = 'radio';

        if (isset($sets['values'])) {
            $this->sets['values'] = $sets['values']; 
        }
    }
    
    public function renderHTML()
    {

        $html = parent::renderHTML();

        $options = array();
        if (isset($this->sets['values'])) {
            $values = explode('|', $this->sets['values']);
            foreach ($values as $value) {
                $tmp = explode(':', $value);
                if (count($tmp) > 1 ) {
                    $options[$tmp[0]] = $tmp[1];
                } else {
                    $options[$tmp[0]] = $tmp[0];
                }
            }
            
            $radioHTML = ''; $i = 0;
            foreach ($options as $key => $value) {
                $i++;
                if ($this->sets['value'] == $key) {
                    $checked = 'CHECKED';
                } else {
                    $checked = '';
                }

                $tmp = $html;
                $tmp = str_replace('[RADIO_CLASS]', $this->getClass(), $tmp);
                $tmp = str_replace('[RADIO_ID]', $this->sets['id'] . '-' . $i, $tmp);
                $tmp = str_replace('[RADIO_NAME]', $this->sets['id'], $tmp);
                $tmp = str_replace('[RADIO_KEY]', $key, $tmp);
                $tmp = str_replace('[RADIO_CHECKED]', $checked, $tmp);
                $tmp = str_replace('[RADIO_REQUIRED]', $this->getRequired(), $tmp);
                $tmp = str_replace('[RADIO_OTHER]', $this->getOther(), $tmp);
                $tmp = str_replace('[RADIO_VALUE]', $value, $tmp);

                $radioHTML .= "\r\n" . $tmp;
            }
        }
        return $radioHTML;
        
    }
    
    
    public function renderHTML_old()
    {
        if (isset($this->sets['id'])) {
            $id = $this->sets['id'];
            unset($this->sets['id']);
        } else {
            echo __('Az ID nincs beállítva!', 'dovi-form');
            exit;
        }

        $value = '';
        if (isset($this->sets['value'])) {
            if (strtoupper($this->sets['value']) == 'COOKIE') {
                if (isset($_COOKIE[$id])) {
                    $value = $_COOKIE[$id];
                } else {
                    $value = '';
                }
            } else {
                if ($this->sets['value'] == '') {
                    if (isset($_REQUEST[$id])) {
                        $value = sanitize_text_field($_REQUEST[$id]);
                    };
                } else {
                    $value = $this->sets['value'];
                }
            }
            unset($this->sets['value']);
        }

        if (isset($this->sets['class'])) { $class = $this->sets['class']; } else { $class = '';}
        if (isset($this->sets['invalid'])) { $invalidText = $this->sets['invalid']; } else { $invalidText = '';}
        if (isset($this->sets['other'])) { $other = $this->sets['other']; } else { $other = '';}

        if (isset($this->sets['required'])) { 
            $required = 'required="required"';
            $check = 'onkeypress="form_item_check(\''.$this->sets['id'].'\');" '; 
        } else { 
            $required = '';
            $check = '';
        }

        $values = array();
        $tmp = explode('|', $this->sets['values']);
        foreach ($tmp as $item) {
            $t = explode(':', $item);
            if (count($t) > 1 ) {
                $values[$t[0]] = $t[1];
            } else {
                $values[$t[0]] = $t[0];
            }
        }

        if (isset($this->sets['checked'])) {
            $checked = 'CHECKED';
        } else {
            $checked = '';
        }

        $html = "\r\n";
        
        $i = 0;
        $labels = array();
        foreach ($values as $key => $v) {
            $i++;

            if ($value == $key) {
                $checked = 'CHECKED';
            } else {
                $checked = '';
            }

            $html .= 
                '<div class="custom-control custom-radio">' . "\r\n" .
                '   <input type="radio" class="'.$class.' custom-control-input" id="'.$id.$i.'" name="'.$id.'" value="'.$key.'" '.$checked.' '.$required.' '.$other.'>' . "\r\n" .
                '   <label class="custom-control-label" for="'.$id.$i.'">'.$v.'</label>' . "\r\n" . 
                '</div>' . "\r\n";
            $labels[] = $key.'::'.$v;
        }
        $labels = implode('|', $labels);
        if (isset($this->sets['mode']) and ($this->sets['mode'] == 'all')) {
            $html .= '<input type="hidden" id="'.$id.'_all" name="'.$id.'_all" value="'.$labels.'" />';
        }
        if (isset($this->sets['description'])) {
            $html .= '<small class="form-text text-muted">' .  $this->sets['description'] . '</small>' .  "\r\n";
        }

        return $html;
    }
}

?>